diff -urp webkitgtk-2.36.0.icu60/Source/JavaScriptCore/runtime/IntlNumberFormat.cpp webkitgtk-2.36.0.icu52/Source/JavaScriptCore/runtime/IntlNumberFormat.cpp
--- webkitgtk-2.36.0.icu60/Source/JavaScriptCore/runtime/IntlNumberFormat.cpp	2022-02-23 02:58:53.000000000 -0600
+++ webkitgtk-2.36.0.icu52/Source/JavaScriptCore/runtime/IntlNumberFormat.cpp	2022-03-28 15:11:04.214708945 -0500
@@ -35,43 +35,26 @@
 #include "JSBoundFunction.h"
 #include "JSCInlines.h"
 #include "ObjectConstructor.h"
-#include <wtf/Range.h>
 #include <wtf/unicode/icu/ICUHelpers.h>
 
-#ifdef U_HIDE_DRAFT_API
-#undef U_HIDE_DRAFT_API
-#endif
-#if HAVE(ICU_U_NUMBER_FORMATTER)
-#include <unicode/unumberformatter.h>
-#endif
-#if HAVE(ICU_U_NUMBER_RANGE_FORMATTER)
-#include <unicode/unumberrangeformatter.h>
-#endif
-#define U_HIDE_DRAFT_API 1
-
 namespace JSC {
 
 const ClassInfo IntlNumberFormat::s_info = { "Object", &Base::s_info, nullptr, nullptr, CREATE_METHOD_TABLE(IntlNumberFormat) };
 
 namespace IntlNumberFormatInternal {
-static constexpr bool verbose = false;
+constexpr bool verbose = false;
 }
 
-#if HAVE(ICU_U_NUMBER_FORMATTER)
-void UNumberFormatterDeleter::operator()(UNumberFormatter* formatter)
-{
-    if (formatter)
-        unumf_close(formatter);
-}
-#endif
+struct IntlNumberFormatField {
+    int32_t type;
+    size_t size;
+};
 
-#if HAVE(ICU_U_NUMBER_RANGE_FORMATTER)
-void UNumberRangeFormatterDeleter::operator()(UNumberRangeFormatter* formatter)
+void IntlNumberFormat::UNumberFormatDeleter::operator()(UNumberFormat* numberFormat) const
 {
-    if (formatter)
-        unumrf_close(formatter);
+    if (numberFormat)
+        unum_close(numberFormat);
 }
-#endif
 
 IntlNumberFormat* IntlNumberFormat::create(VM& vm, Structure* structure)
 {
@@ -140,7 +123,7 @@ static unsigned computeCurrencyDigits(co
     // 11.1.1 The abstract operation CurrencyDigits (currency)
     // "If the ISO 4217 currency and funds code list contains currency as an alphabetic code,
     // then return the minor unit value corresponding to the currency from the list; else return 2.
-    static constexpr std::pair<const char*, unsigned> currencyMinorUnits[] = {
+    std::pair<const char*, unsigned> currencyMinorUnits[] = {
         { "BHD", 3 },
         { "BIF", 0 },
         { "BYR", 0 },
@@ -174,119 +157,6 @@ static unsigned computeCurrencyDigits(co
     return 2;
 }
 
-static std::optional<MeasureUnit> sanctionedSimpleUnitIdentifier(StringView unitIdentifier)
-{
-    ASSERT(
-        std::is_sorted(std::begin(simpleUnits), std::end(simpleUnits),
-            [](const MeasureUnit& a, const MeasureUnit& b) {
-                return WTF::codePointCompare(StringView(a.subType), StringView(b.subType)) < 0;
-            }));
-
-    auto iterator = std::lower_bound(std::begin(simpleUnits), std::end(simpleUnits), unitIdentifier,
-        [](const MeasureUnit& unit, StringView unitIdentifier) {
-            return WTF::codePointCompare(StringView(unit.subType), unitIdentifier) < 0;
-        });
-    if (iterator != std::end(simpleUnits) && iterator->subType == unitIdentifier)
-        return *iterator;
-    return std::nullopt;
-}
-
-struct WellFormedUnit {
-public:
-    explicit WellFormedUnit(MeasureUnit numerator)
-        : numerator(numerator)
-    {
-    }
-
-    WellFormedUnit(MeasureUnit numerator, MeasureUnit denominator)
-        : numerator(numerator)
-        , denominator(denominator)
-    {
-    }
-
-    MeasureUnit numerator;
-    std::optional<MeasureUnit> denominator;
-};
-
-static std::optional<WellFormedUnit> wellFormedUnitIdentifier(StringView unitIdentifier)
-{
-    // https://tc39.es/ecma402/#sec-iswellformedunitidentifier
-    if (auto unit = sanctionedSimpleUnitIdentifier(unitIdentifier))
-        return WellFormedUnit(unit.value());
-
-    // If the substring "-per-" does not occur exactly once in unitIdentifier, then return false.
-    auto per = StringView("-per-"_s);
-    auto position = unitIdentifier.find(per);
-    if (position == WTF::notFound)
-        return std::nullopt;
-    if (unitIdentifier.find(per, position + per.length()) != WTF::notFound)
-        return std::nullopt;
-
-    // If the result of IsSanctionedSimpleUnitIdentifier(numerator) is false, then return false.
-    auto numerator = unitIdentifier.substring(0, position);
-    auto numeratorUnit = sanctionedSimpleUnitIdentifier(numerator);
-    if (!numeratorUnit)
-        return std::nullopt;
-
-    // If the result of IsSanctionedSimpleUnitIdentifier(denominator) is false, then return false.
-    auto denominator = unitIdentifier.substring(position + per.length());
-    auto denominatorUnit = sanctionedSimpleUnitIdentifier(denominator);
-    if (!denominatorUnit)
-        return std::nullopt;
-
-    return WellFormedUnit(numeratorUnit.value(), denominatorUnit.value());
-}
-
-static ASCIILiteral partTypeString(UNumberFormatFields field, IntlNumberFormat::Style style, bool sign, IntlMathematicalValue::NumberType type)
-{
-    switch (field) {
-    case UNUM_INTEGER_FIELD:
-        switch (type) {
-        case IntlMathematicalValue::NumberType::NaN:
-            return "nan"_s;
-        case IntlMathematicalValue::NumberType::Infinity:
-            return "infinity"_s;
-        case IntlMathematicalValue::NumberType::Integer:
-            return "integer"_s;
-        }
-        ASSERT_NOT_REACHED();
-        return "unknown"_s;
-    case UNUM_FRACTION_FIELD:
-        return "fraction"_s;
-    case UNUM_DECIMAL_SEPARATOR_FIELD:
-        return "decimal"_s;
-    case UNUM_EXPONENT_SYMBOL_FIELD:
-        return "exponentSeparator"_s;
-    case UNUM_EXPONENT_SIGN_FIELD:
-        return "exponentMinusSign"_s;
-    case UNUM_EXPONENT_FIELD:
-        return "exponentInteger"_s;
-    case UNUM_GROUPING_SEPARATOR_FIELD:
-        return "group"_s;
-    case UNUM_CURRENCY_FIELD:
-        return "currency"_s;
-    case UNUM_PERCENT_FIELD:
-        // If the style is "unit", we should report as unit.
-        // JSTests/test262/test/intl402/NumberFormat/prototype/formatToParts/percent-en-US.js
-        return (style == IntlNumberFormat::Style::Unit) ? "unit"_s : "percentSign"_s;
-    case UNUM_SIGN_FIELD:
-        return sign ? "minusSign"_s : "plusSign"_s;
-#if HAVE(ICU_U_NUMBER_FORMATTER)
-    case UNUM_MEASURE_UNIT_FIELD:
-        return "unit"_s;
-    case UNUM_COMPACT_FIELD:
-        return "compact"_s;
-#endif
-    // These should not show up because there is no way to specify them in NumberFormat options.
-    // If they do, they don't fit well into any of known part types, so consider it an "unknown".
-    case UNUM_PERMILL_FIELD:
-    // Any newer additions to the UNumberFormatFields enum should just be considered an "unknown" part.
-    default:
-        return "unknown"_s;
-    }
-    return "unknown"_s;
-}
-
 // https://tc39.github.io/ecma402/#sec-initializenumberformat
 void IntlNumberFormat::initializeNumberFormat(JSGlobalObject* globalObject, JSValue locales, JSValue optionsValue)
 {
@@ -325,7 +195,7 @@ void IntlNumberFormat::initializeNumberF
 
     m_numberingSystem = resolved.extensions[static_cast<unsigned>(RelevantExtensionKey::Nu)];
 
-    m_style = intlOption<Style>(globalObject, options, vm.propertyNames->style, { { "decimal"_s, Style::Decimal }, { "percent"_s, Style::Percent }, { "currency"_s, Style::Currency }, { "unit"_s, Style::Unit } }, "style must be either \"decimal\", \"percent\", \"currency\", or \"unit\""_s, Style::Decimal);
+    m_style = intlOption<Style>(globalObject, options, vm.propertyNames->style, { { "decimal"_s, Style::Decimal }, { "percent"_s, Style::Percent }, { "currency"_s, Style::Currency } }, "style must be either \"decimal\", \"percent\", or \"currency\""_s, Style::Decimal);
     RETURN_IF_EXCEPTION(scope, void());
 
     String currency = intlStringOption(globalObject, options, Identifier::fromString(vm, "currency"), { }, nullptr, nullptr);
@@ -349,304 +219,51 @@ void IntlNumberFormat::initializeNumberF
         currencyDigits = computeCurrencyDigits(currency);
     }
 
-    m_currencyDisplay = intlOption<CurrencyDisplay>(globalObject, options, Identifier::fromString(vm, "currencyDisplay"), { { "code"_s, CurrencyDisplay::Code }, { "symbol"_s, CurrencyDisplay::Symbol }, { "narrowSymbol"_s, CurrencyDisplay::NarrowSymbol }, { "name"_s, CurrencyDisplay::Name } }, "currencyDisplay must be either \"code\", \"symbol\", or \"name\""_s, CurrencyDisplay::Symbol);
+    m_currencyDisplay = intlOption<CurrencyDisplay>(globalObject, options, Identifier::fromString(vm, "currencyDisplay"), { { "code"_s, CurrencyDisplay::Code }, { "symbol"_s, CurrencyDisplay::Symbol }, { "name"_s, CurrencyDisplay::Name } }, "currencyDisplay must be either \"code\", \"symbol\", or \"name\""_s, CurrencyDisplay::Symbol);
     RETURN_IF_EXCEPTION(scope, void());
 
-    m_currencySign = intlOption<CurrencySign>(globalObject, options, Identifier::fromString(vm, "currencySign"), { { "standard"_s, CurrencySign::Standard }, { "accounting"_s, CurrencySign::Accounting } }, "currencySign must be either \"standard\" or \"accounting\""_s, CurrencySign::Standard);
-    RETURN_IF_EXCEPTION(scope, void());
-
-    String unit = intlStringOption(globalObject, options, Identifier::fromString(vm, "unit"), { }, nullptr, nullptr);
-    RETURN_IF_EXCEPTION(scope, void());
-    std::optional<WellFormedUnit> wellFormedUnit;
-    if (!unit.isNull()) {
-        wellFormedUnit = wellFormedUnitIdentifier(unit);
-        if (!wellFormedUnit) {
-            throwRangeError(globalObject, scope, "unit is not a well-formed unit identifier"_s);
-            return;
-        }
-        m_unit = unit;
-    } else if (m_style == Style::Unit) {
-        throwTypeError(globalObject, scope, "unit must be a string"_s);
-        return;
-    }
-
-    m_unitDisplay = intlOption<UnitDisplay>(globalObject, options, Identifier::fromString(vm, "unitDisplay"), { { "short"_s, UnitDisplay::Short }, { "narrow"_s, UnitDisplay::Narrow }, { "long"_s, UnitDisplay::Long } }, "unitDisplay must be either \"short\", \"narrow\", or \"long\""_s, UnitDisplay::Short);
+    unsigned minimumIntegerDigits = intlNumberOption(globalObject, options, Identifier::fromString(vm, "minimumIntegerDigits"), 1, 21, 1);
     RETURN_IF_EXCEPTION(scope, void());
+    m_minimumIntegerDigits = minimumIntegerDigits;
 
     unsigned minimumFractionDigitsDefault = (m_style == Style::Currency) ? currencyDigits : 0;
-    unsigned maximumFractionDigitsDefault = (m_style == Style::Currency) ? currencyDigits : (m_style == Style::Percent) ? 0 : 3;
-
-    m_notation = intlOption<IntlNotation>(globalObject, options, Identifier::fromString(vm, "notation"), { { "standard"_s, IntlNotation::Standard }, { "scientific"_s, IntlNotation::Scientific }, { "engineering"_s, IntlNotation::Engineering }, { "compact"_s, IntlNotation::Compact } }, "notation must be either \"standard\", \"scientific\", \"engineering\", or \"compact\""_s, IntlNotation::Standard);
-    RETURN_IF_EXCEPTION(scope, void());
-
-    setNumberFormatDigitOptions(globalObject, this, options, minimumFractionDigitsDefault, maximumFractionDigitsDefault, m_notation);
-    RETURN_IF_EXCEPTION(scope, void());
-
-    m_roundingIncrement = intlNumberOption(globalObject, options, vm.propertyNames->roundingIncrement, 1, 5000, 1);
-    RETURN_IF_EXCEPTION(scope, void());
-    static constexpr const unsigned roundingIncrementCandidates[] = {
-        1, 2, 5, 10, 20, 25, 50, 100, 200, 250, 500, 1000, 2000, 2500, 5000
-    };
-    if (std::none_of(roundingIncrementCandidates, roundingIncrementCandidates + std::size(roundingIncrementCandidates),
-        [&](unsigned candidate) {
-            return candidate == m_roundingIncrement;
-        })) {
-        throwRangeError(globalObject, scope, "roundingIncrement must be one of 1, 2, 5, 10, 20, 25, 50, 100, 200, 250, 500, 1000, 2000, 2500, 5000"_s);
-        return;
-    }
-    if (m_roundingIncrement != 1 && m_roundingType != IntlRoundingType::FractionDigits) {
-        throwRangeError(globalObject, scope, "rounding type is not fraction-digits while roundingIncrement is specified"_s);
-        return;
-    }
-
-    m_trailingZeroDisplay = intlOption<TrailingZeroDisplay>(globalObject, options, vm.propertyNames->trailingZeroDisplay, { { "auto"_s, TrailingZeroDisplay::Auto }, { "stripIfInteger"_s, TrailingZeroDisplay::StripIfInteger } }, "trailingZeroDisplay must be either \"auto\" or \"stripIfInteger\""_s, TrailingZeroDisplay::Auto);
     RETURN_IF_EXCEPTION(scope, void());
 
-    m_compactDisplay = intlOption<CompactDisplay>(globalObject, options, Identifier::fromString(vm, "compactDisplay"), { { "short"_s, CompactDisplay::Short }, { "long"_s, CompactDisplay::Long } }, "compactDisplay must be either \"short\" or \"long\""_s, CompactDisplay::Short);
+    unsigned minimumFractionDigits = intlNumberOption(globalObject, options, Identifier::fromString(vm, "minimumFractionDigits"), 0, 20, minimumFractionDigitsDefault);
     RETURN_IF_EXCEPTION(scope, void());
+    m_minimumFractionDigits = minimumFractionDigits;
 
-    UseGrouping defaultUseGrouping = UseGrouping::Auto;
-    if (m_notation == IntlNotation::Compact)
-        defaultUseGrouping = UseGrouping::Min2;
+    unsigned maximumFractionDigitsDefault;
+    if (m_style == Style::Currency)
+        maximumFractionDigitsDefault = std::max(minimumFractionDigits, currencyDigits);
+    else if (m_style == Style::Percent)
+        maximumFractionDigitsDefault = minimumFractionDigits;
+    else
+        maximumFractionDigitsDefault = std::max(minimumFractionDigits, 3u);
 
-    m_useGrouping = intlStringOrBooleanOption<UseGrouping>(globalObject, options, Identifier::fromString(vm, "useGrouping"), UseGrouping::Always, UseGrouping::False, { { "min2"_s, UseGrouping::Min2 }, { "auto"_s, UseGrouping::Auto }, { "always"_s, UseGrouping::Always } }, "useGrouping must be either true, false, \"min2\", \"auto\", or \"always\""_s, defaultUseGrouping);
+    unsigned maximumFractionDigits = intlNumberOption(globalObject, options, Identifier::fromString(vm, "maximumFractionDigits"), minimumFractionDigits, 20, maximumFractionDigitsDefault);
     RETURN_IF_EXCEPTION(scope, void());
+    m_maximumFractionDigits = maximumFractionDigits;
 
-    m_signDisplay = intlOption<SignDisplay>(globalObject, options, Identifier::fromString(vm, "signDisplay"), { { "auto"_s, SignDisplay::Auto }, { "never"_s, SignDisplay::Never }, { "always"_s, SignDisplay::Always }, { "exceptZero"_s, SignDisplay::ExceptZero }, { "negative"_s, SignDisplay::Negative } }, "signDisplay must be either \"auto\", \"never\", \"always\", \"exceptZero\", or \"negative\""_s, SignDisplay::Auto);
+    JSValue minimumSignificantDigitsValue = options->get(globalObject, Identifier::fromString(vm, "minimumSignificantDigits"));
     RETURN_IF_EXCEPTION(scope, void());
 
-    m_roundingMode = intlOption<RoundingMode>(globalObject, options, vm.propertyNames->roundingMode, {
-            { "ceil"_s, RoundingMode::Ceil },
-            { "floor"_s, RoundingMode::Floor },
-            { "expand"_s, RoundingMode::Expand },
-            { "trunc"_s, RoundingMode::Trunc },
-            { "halfCeil"_s, RoundingMode::HalfCeil },
-            { "halfFloor"_s, RoundingMode::HalfFloor },
-            { "halfExpand"_s, RoundingMode::HalfExpand },
-            { "halfTrunc"_s, RoundingMode::HalfTrunc },
-            { "halfEven"_s, RoundingMode::HalfEven }
-        }, "roundingMode must be either \"ceil\", \"floor\", \"expand\", \"trunc\", \"halfCeil\", \"halfFloor\", \"halfExpand\", \"halfTrunc\", or \"halfEven\""_s, RoundingMode::HalfExpand);
+    JSValue maximumSignificantDigitsValue = options->get(globalObject, Identifier::fromString(vm, "maximumSignificantDigits"));
     RETURN_IF_EXCEPTION(scope, void());
 
-    CString dataLocaleWithExtensions = makeString(resolved.dataLocale, "-u-nu-", m_numberingSystem).utf8();
-    dataLogLnIf(IntlNumberFormatInternal::verbose, "dataLocaleWithExtensions:(", dataLocaleWithExtensions , ")");
-
-    // Options are obtained. Configure formatter here.
-
-#if HAVE(ICU_U_NUMBER_FORMATTER)
-    // Constructing ICU Number Skeletons to configure UNumberFormatter.
-    // https://github.com/unicode-org/icu/blob/master/docs/userguide/format_parse/numbers/skeletons.md
-
-    StringBuilder skeletonBuilder;
-
-    switch (m_roundingMode) {
-    case RoundingMode::Ceil:
-        skeletonBuilder.append("rounding-mode-ceiling");
-        break;
-    case RoundingMode::Floor:
-        skeletonBuilder.append("rounding-mode-floor");
-        break;
-    case RoundingMode::Expand:
-        skeletonBuilder.append("rounding-mode-up");
-        break;
-    case RoundingMode::Trunc:
-        skeletonBuilder.append("rounding-mode-down");
-        break;
-    case RoundingMode::HalfCeil: {
-        // Only ICU69~ supports half-ceiling. Ignore this option if linked ICU does not support it.
-        // https://github.com/unicode-org/icu/commit/e8dfea9bb6bb27596731173b352759e44ad06b21
-        if (WTF::ICU::majorVersion() >= 69)
-            skeletonBuilder.append("rounding-mode-half-ceiling");
-        else
-            skeletonBuilder.append("rounding-mode-half-up"); // Default option.
-        break;
-    }
-    case RoundingMode::HalfFloor: {
-        // Only ICU69~ supports half-ceil. Ignore this option if linked ICU does not support it.
-        // https://github.com/unicode-org/icu/commit/e8dfea9bb6bb27596731173b352759e44ad06b21
-        if (WTF::ICU::majorVersion() >= 69)
-            skeletonBuilder.append("rounding-mode-half-floor");
-        else
-            skeletonBuilder.append("rounding-mode-half-up"); // Default option.
-        break;
-    }
-    case RoundingMode::HalfExpand:
-        skeletonBuilder.append("rounding-mode-half-up");
-        break;
-    case RoundingMode::HalfTrunc:
-        skeletonBuilder.append("rounding-mode-half-down");
-        break;
-    case RoundingMode::HalfEven:
-        skeletonBuilder.append("rounding-mode-half-even");
-        break;
-    }
-
-    switch (m_style) {
-    case Style::Decimal:
-        // No skeleton is needed.
-        break;
-    case Style::Percent:
-        skeletonBuilder.append(" percent scale/100");
-        break;
-    case Style::Currency: {
-        skeletonBuilder.append(" currency/", currency);
-
-        // https://github.com/unicode-org/icu/blob/master/docs/userguide/format_parse/numbers/skeletons.md#unit-width
-        switch (m_currencyDisplay) {
-        case CurrencyDisplay::Code:
-            skeletonBuilder.append(" unit-width-iso-code");
-            break;
-        case CurrencyDisplay::Symbol:
-            // Default option. Do not specify unit-width.
-            break;
-        case CurrencyDisplay::NarrowSymbol:
-            skeletonBuilder.append(" unit-width-narrow");
-            break;
-        case CurrencyDisplay::Name:
-            skeletonBuilder.append(" unit-width-full-name");
-            break;
-        }
-        break;
-    }
-    case Style::Unit: {
-        // The measure-unit stem takes one required option: the unit identifier of the unit to be formatted.
-        // The full unit identifier is required: both the type and the subtype (for example, length-meter).
-        // https://github.com/unicode-org/icu/blob/master/docs/userguide/format_parse/numbers/skeletons.md#unit
-        skeletonBuilder.append(" measure-unit/");
-        auto numeratorUnit = wellFormedUnit->numerator;
-        skeletonBuilder.append(numeratorUnit.type, '-', numeratorUnit.subType);
-        if (auto denominatorUnitValue = wellFormedUnit->denominator) {
-            auto denominatorUnit = denominatorUnitValue.value();
-            skeletonBuilder.append(" per-measure-unit/", denominatorUnit.type, '-', denominatorUnit.subType);
-        }
-
-        // https://github.com/unicode-org/icu/blob/master/docs/userguide/format_parse/numbers/skeletons.md#unit-width
-        switch (m_unitDisplay) {
-        case UnitDisplay::Short:
-            skeletonBuilder.append(" unit-width-short");
-            break;
-        case UnitDisplay::Narrow:
-            skeletonBuilder.append(" unit-width-narrow");
-            break;
-        case UnitDisplay::Long:
-            skeletonBuilder.append(" unit-width-full-name");
-            break;
-        }
-        break;
-    }
-    }
-
-    appendNumberFormatDigitOptionsToSkeleton(this, skeletonBuilder);
-
-    // Configure this just after precision.
-    // https://github.com/unicode-org/icu/blob/main/docs/userguide/format_parse/numbers/skeletons.md#trailing-zero-display
-    switch (m_trailingZeroDisplay) {
-    case TrailingZeroDisplay::Auto:
-        break;
-    case TrailingZeroDisplay::StripIfInteger:
-        // Only ICU69~ supports trailing zero display. Ignore this option if linked ICU does not support it.
-        // https://github.com/unicode-org/icu/commit/b79c299f90d4023ac237db3d0335d568bf21cd36
-        if (WTF::ICU::majorVersion() >= 69)
-            skeletonBuilder.append("/w");
-        break;
-    }
-
-    // https://github.com/unicode-org/icu/blob/master/docs/userguide/format_parse/numbers/skeletons.md#notation
-    switch (m_notation) {
-    case IntlNotation::Standard:
-        break;
-    case IntlNotation::Scientific:
-        skeletonBuilder.append(" scientific");
-        break;
-    case IntlNotation::Engineering:
-        skeletonBuilder.append(" engineering");
-        break;
-    case IntlNotation::Compact:
-        switch (m_compactDisplay) {
-        case CompactDisplay::Short:
-            skeletonBuilder.append(" compact-short");
-            break;
-        case CompactDisplay::Long:
-            skeletonBuilder.append(" compact-long");
-            break;
-        }
-        break;
-    }
-
-    // https://github.com/unicode-org/icu/blob/master/docs/userguide/format_parse/numbers/skeletons.md#sign-display
-    // CurrencySign's accounting is a part of SignDisplay in ICU.
-    bool useAccounting = (m_style == Style::Currency && m_currencySign == CurrencySign::Accounting);
-    switch (m_signDisplay) {
-    case SignDisplay::Auto:
-        if (useAccounting)
-            skeletonBuilder.append(" sign-accounting");
-        else
-            skeletonBuilder.append(" sign-auto");
-        break;
-    case SignDisplay::Never:
-        skeletonBuilder.append(" sign-never");
-        break;
-    case SignDisplay::Always:
-        if (useAccounting)
-            skeletonBuilder.append(" sign-accounting-always");
-        else
-            skeletonBuilder.append(" sign-always");
-        break;
-    case SignDisplay::ExceptZero:
-        if (useAccounting)
-            skeletonBuilder.append(" sign-accounting-except-zero");
-        else
-            skeletonBuilder.append(" sign-except-zero");
-        break;
-    case SignDisplay::Negative:
-        // Only ICU69~ supports negative sign display. Ignore this option if linked ICU does not support it.
-        // https://github.com/unicode-org/icu/commit/1aa0dad8e06ecc99bff442dd37f6daa2d39d9a5a
-        if (WTF::ICU::majorVersion() >= 69) {
-            if (useAccounting)
-                skeletonBuilder.append(" sign-accounting-negative");
-            else
-                skeletonBuilder.append(" sign-negative");
-        }
-        break;
-    }
-
-    // https://github.com/tc39/proposal-intl-numberformat-v3/issues/3
-    // https://github.com/unicode-org/icu/blob/main/docs/userguide/format_parse/numbers/skeletons.md#grouping
-    switch (m_useGrouping) {
-    case UseGrouping::False:
-        skeletonBuilder.append(" group-off");
-        break;
-    case UseGrouping::Min2:
-        skeletonBuilder.append(" group-min2");
-        break;
-    case UseGrouping::Auto:
-        skeletonBuilder.append(" group-auto");
-        break;
-    case UseGrouping::Always:
-        skeletonBuilder.append(" group-on-aligned");
-        break;
+    if (!minimumSignificantDigitsValue.isUndefined() || !maximumSignificantDigitsValue.isUndefined()) {
+        unsigned minimumSignificantDigits = intlDefaultNumberOption(globalObject, minimumSignificantDigitsValue, Identifier::fromString(vm, "minimumSignificantDigits"), 1, 21, 1);
+        RETURN_IF_EXCEPTION(scope, void());
+        unsigned maximumSignificantDigits = intlDefaultNumberOption(globalObject, maximumSignificantDigitsValue, Identifier::fromString(vm, "maximumSignificantDigits"), minimumSignificantDigits, 21, 21);
+        RETURN_IF_EXCEPTION(scope, void());
+        m_minimumSignificantDigits = minimumSignificantDigits;
+        m_maximumSignificantDigits = maximumSignificantDigits;
     }
 
-    String skeleton = skeletonBuilder.toString();
-    dataLogLnIf(IntlNumberFormatInternal::verbose, skeleton);
-    StringView skeletonView(skeleton);
-    auto upconverted = skeletonView.upconvertedCharacters();
-
-    UErrorCode status = U_ZERO_ERROR;
-    m_numberFormatter = std::unique_ptr<UNumberFormatter, UNumberFormatterDeleter>(unumf_openForSkeletonAndLocale(upconverted.get(), skeletonView.length(), dataLocaleWithExtensions.data(), &status));
-    if (U_FAILURE(status)) {
-        throwTypeError(globalObject, scope, "Failed to initialize NumberFormat"_s);
-        return;
-    }
+    TriState useGrouping = intlBooleanOption(globalObject, options, Identifier::fromString(vm, "useGrouping"));
+    RETURN_IF_EXCEPTION(scope, void());
+    m_useGrouping = useGrouping != TriState::False;
 
-#if HAVE(ICU_U_NUMBER_RANGE_FORMATTER)
-    m_numberRangeFormatter = std::unique_ptr<UNumberRangeFormatter, UNumberRangeFormatterDeleter>(unumrf_openForSkeletonWithCollapseAndIdentityFallback(upconverted.get(), skeletonView.length(), UNUM_RANGE_COLLAPSE_AUTO, UNUM_IDENTITY_FALLBACK_APPROXIMATELY, dataLocaleWithExtensions.data(), nullptr, &status));
-    if (U_FAILURE(status)) {
-        throwTypeError(globalObject, scope, "failed to initialize NumberFormat"_s);
-        return;
-    }
-#endif
-#else
     UNumberFormatStyle style = UNUM_DEFAULT;
     switch (m_style) {
     case Style::Decimal:
@@ -663,49 +280,19 @@ void IntlNumberFormat::initializeNumberF
         case CurrencyDisplay::Symbol:
             style = UNUM_CURRENCY;
             break;
-        case CurrencyDisplay::NarrowSymbol:
-            style = UNUM_CURRENCY; // Use the same option to "symbol" since linked-ICU does not support it.
-            break;
         case CurrencyDisplay::Name:
             style = UNUM_CURRENCY_PLURAL;
             break;
+        default:
+            ASSERT_NOT_REACHED();
         }
-        switch (m_currencySign) {
-        case CurrencySign::Standard:
-            break;
-        case CurrencySign::Accounting:
-            // Ignore this case since linked ICU does not support it.
-            break;
-        }
-        break;
-    case Style::Unit:
-        // Ignore this case since linked ICU does not support it.
-        break;
-    }
-
-    switch (m_notation) {
-    case IntlNotation::Standard:
-        break;
-    case IntlNotation::Scientific:
-    case IntlNotation::Engineering:
-    case IntlNotation::Compact:
-        // Ignore this case since linked ICU does not support it.
-        break;
-    }
-
-    switch (m_signDisplay) {
-    case SignDisplay::Auto:
-        break;
-    case SignDisplay::Never:
-    case SignDisplay::Always:
-    case SignDisplay::ExceptZero:
-    case SignDisplay::Negative:
-        // Ignore this case since linked ICU does not support it.
         break;
+    default:
+        ASSERT_NOT_REACHED();
     }
 
     UErrorCode status = U_ZERO_ERROR;
-    m_numberFormat = std::unique_ptr<UNumberFormat, ICUDeleter<unum_close>>(unum_open(style, nullptr, 0, dataLocaleWithExtensions.data(), nullptr, &status));
+    m_numberFormat = std::unique_ptr<UNumberFormat, UNumberFormatDeleter>(unum_open(style, nullptr, 0, m_locale.utf8().data(), nullptr, &status));
     if (U_FAILURE(status)) {
         throwTypeError(globalObject, scope, "failed to initialize NumberFormat"_s);
         return;
